--|> LDB
-----------------------------------------------------------
local ADDON_NAME, NS = ...

local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
if not ldb then
    NS.PrintAddonMessage("LibDataBroker-1.1 not found!")
    return
end

--> Create LDB plugin
----------------------------------------
local plugin =
    ldb:NewDataObject(
    ADDON_NAME,
    {
        type = "data source",
        text = "0",
        icon = NS.Constants.Paths.mediaPath .. "Icons\\minimap.tga"
    }
)

--> OnClick
----------------------------------------
function plugin.OnClick(_, button)
    if button == "RightButton" then
        if FTLCharOptions.Enabled == true then
            NS.Disable()
            NS.PrintAddonMessage(NS.Constants.Strings.Disabled)
            FTLCharOptions.Enabled = false
        else
            NS.Enable()
            NS.PrintAddonMessage(NS.Constants.Strings.Enabled)
            FTLCharOptions.Enabled = true
        end
    end
end

--> OnTooltipShow
----------------------------------------
function plugin.OnTooltipShow(tip)
    if FTLCharOptions.Enabled == true then
        tip:AddDoubleLine(NS.Constants.Strings.addonTitle, NS.Constants.Strings.Active)
    else
        tip:AddDoubleLine(NS.Constants.Strings.addonTitle, NS.Constants.Strings.Inactive)
    end
    tip:AddLine("Right-Click to toggle the addon")
end

--> Enable on Login
----------------------------------------
local f = CreateFrame("Frame")
f:SetScript(
    "OnEvent",
    function()
        NS.LDBIcon = NS.LDBIcon or LibStub("LibDBIcon-1.0", true)
        if not NS.LDBIcon then
            return
        end
        NS.LDBIcon:Register(ADDON_NAME, plugin, FTLCharOptions.LDB)
        LibStub("LibDBIcon-1.0"):Show(ADDON_NAME)
        f:UnregisterEvent("PLAYER_LOGIN")
    end
)
f:RegisterEvent("PLAYER_LOGIN")
