--|> UI
-------------------------------------------------------------------------------
local _, NS = ...

--> Upvalues
local PixelUtil = PixelUtil

--|> BUILD UI
-------------------------------------------------------------------------------
--> Focus
NS.FF = NS.FF or CreateFrame("Frame", "FTL.FF", UIParent)
NS.FF:SetFrameStrata("DIALOG")
PixelUtil.SetPoint(NS.FF, "CENTER", UIParent, "CENTER", 0, 0)
PixelUtil.SetSize(NS.FF, 64, 64)
NS.FF:SetIgnoreParentAlpha(true)

--> Range Text
NS.FF.RangeText = NS.FF.RangeText or NS.FF:CreateFontString(nil, "ARTWORK", nil)
NS.FF.RangeText:SetFont([[interface\addons\FTL\Media\Fonts\RobotoCondensed-Bold.ttf]], 20, "OUTLINE")
PixelUtil.SetPoint(NS.FF.RangeText, "BOTTOM", NS.FF, "TOP", 0, 2)
NS.FF.RangeText:SetJustifyH("CENTER")
NS.FF.RangeText:SetShadowOffset(1, -1)
NS.FF.RangeText:SetText("--")
NS.FF.RangeText:SetDrawLayer("ARTWORK", 7)

--> Texture
NS.FF.icon = NS.FF.icon or NS.FF:CreateTexture(nil, "ARTWORK", NS.FF)
NS.FF.icon:SetTexture([[interface/addons/FTL/Media/Textures/fTexture.tga]])
NS.FF.icon:SetAllPoints()
NS.FF.icon:SetAlpha(1)
NS.FF.icon:SetBlendMode("BLEND")
NS.FF.faction = NS.FF.faction or NS.FF:CreateTexture(nil, "OVERLAY", NS.FF)
NS.FF.faction:SetTexture([[interface/Timer/Horde-Logo]])
NS.FF.faction:SetDrawLayer("OVERLAY", 2)
NS.FF.faction:SetPoint("TOPLEFT", NS.FF, "TOPLEFT", 2, -2)
NS.FF.faction:SetPoint("BOTTOMRIGHT", NS.FF, "BOTTOMRIGHT", -2, 2)
NS.FF.faction:SetVertexColor(1, 1, 1, 1)
NS.FF:SetAlpha(0)

--> Animations
--> Fade In
NS.FF.FadeIn = NS.FF.FadeIn or NS.FF:CreateAnimationGroup()
NS.FF.FadeIn.s1 = NS.FF.FadeIn.s1 or NS.FF.FadeIn:CreateAnimation("Scale")
NS.FF.FadeIn.s1:SetFromScale(4, 4)
NS.FF.FadeIn.s1:SetToScale(1, 1)
NS.FF.FadeIn.s1:SetDuration(0.25)
NS.FF.FadeIn.s1:SetSmoothing("OUT")
NS.FF.FadeIn.s1:SetOrder(1)
NS.FF.FadeIn.a1 = NS.FF.FadeIn.a1 or NS.FF.FadeIn:CreateAnimation("Alpha")
NS.FF.FadeIn.a1:SetFromAlpha(0)
NS.FF.FadeIn.a1:SetToAlpha(1)
NS.FF.FadeIn.a1:SetDuration(0.25)
NS.FF.FadeIn.a1:SetSmoothing("OUT")
NS.FF.FadeIn.a1:SetOrder(1)

--> Focus Target
NS.FTF = NS.FTF or CreateFrame("Frame", "FTL.FTF", UIParent)
NS.FTF:SetFrameStrata("HIGH")
NS.FTF:SetPoint("CENTER", UIParent)
NS.FTF:SetSize(32, 32)
NS.FTF:SetIgnoreParentAlpha(true)
NS.FTF.icon = NS.FTF.icon or NS.FTF:CreateTexture(nil, "ARTWORK", NS.FTF)
NS.FTF.icon:SetTexture([[interface/addons/FTL/Media/Textures/ftTexture.tga]])
NS.FTF.icon:SetPoint("CENTER", NS.FTF, "CENTER")
NS.FTF.icon:SetSize(32, 32)
NS.FTF.icon:SetDrawLayer("OVERLAY", 1)
NS.FTF.icon:SetVertexColor(1, 0.49, 0, 1)
NS.FTF.icon:SetBlendMode("ADD")
NS.FTF.outline = NS.FTF.outline or NS.FTF:CreateTexture(nil, "BACKGROUND", NS.FTF)
NS.FTF.outline:SetTexture([[interface/addons/FTL/Media/Textures/ftOutline.tga]])
NS.FTF.outline:SetAllPoints()
NS.FTF.outline:SetVertexColor(1, 1, 1, 0.8)
NS.FTF.outline:SetDrawLayer("ARTWORK", 7)
NS.FTF.outline:SetPoint("CENTER", NS.FTF, "CENTER")
NS.FTF.shadow = NS.FTF.shadow or NS.FTF:CreateTexture(nil, "BACKGROUND", NS.FTF)
NS.FTF.shadow:SetTexture([[interface/addons/FTL/Media/Textures/ftShadow.tga]])
NS.FTF.shadow:SetVertexColor(0, 0, 0, 0.5)
NS.FTF.shadow:SetDrawLayer("BACKGROUND")
NS.FTF.shadow:SetAllPoints()
NS.FTF.shadow:SetPoint("CENTER", NS.FTF, "CENTER")
NS.FTF:SetAlpha(0)

--> Animation: Fade In
NS.FTF.FadeIn = NS.FTF.FadeIn or NS.FTF:CreateAnimationGroup()
NS.FTF.FadeIn.s1 = NS.FTF.FadeIn.s1 or NS.FTF.FadeIn:CreateAnimation("Scale")
NS.FTF.FadeIn.s1:SetFromScale(4, 4)
NS.FTF.FadeIn.s1:SetToScale(1, 1)
NS.FTF.FadeIn.s1:SetDuration(0.25)
NS.FTF.FadeIn.s1:SetSmoothing("IN")
NS.FTF.FadeIn.s1:SetOrder(1)
NS.FTF.FadeIn.a1 = NS.FTF.FadeIn.a1 or NS.FTF.FadeIn:CreateAnimation("Alpha")
NS.FTF.FadeIn.a1:SetFromAlpha(0)
NS.FTF.FadeIn.a1:SetToAlpha(1)
NS.FTF.FadeIn.a1:SetDuration(0.25)
NS.FTF.FadeIn.a1:SetSmoothing("IN")
NS.FTF.FadeIn.a1:SetOrder(1)
NS.FTF.FadeIn:SetScript(
    "OnPlay",
    function()
        NS.FTF:SetAlpha(1)
    end
)

--> Animation: TargetedPulse
NS.FTF.TargetedPulse = NS.FTF.TargetedPulse or NS.FTF:CreateAnimationGroup()
NS.FTF.TargetedPulse:SetLooping("REPEAT")
NS.FTF.TargetedPulse.s1 = NS.FTF.TargetedPulse.s1 or NS.FTF.TargetedPulse:CreateAnimation("Scale")
NS.FTF.TargetedPulse.s1:SetFromScale(1, 1)
NS.FTF.TargetedPulse.s1:SetToScale(1.5, 1.5)
NS.FTF.TargetedPulse.s1:SetDuration(0.7)
NS.FTF.TargetedPulse.s1:SetOrder(1)
NS.FTF.TargetedPulse.s2 = NS.FTF.TargetedPulse.s2 or NS.FTF.TargetedPulse:CreateAnimation("Scale")
NS.FTF.TargetedPulse.s2:SetFromScale(1, 1)
NS.FTF.TargetedPulse.s2:SetToScale(0.75, 0.75)
NS.FTF.TargetedPulse.s2:SetDuration(0.7)
NS.FTF.TargetedPulse.s2:SetOrder(2)
